reversed course a bunch but better psfind approach
[feisty_meow.git] / scripts / core / functions.sh
1 #!/bin/bash
2
3 # This defines some general, useful functions.
4
5 #hmmm: starting to get a bit beefy in here.  perhaps there is a good way to refactor the functions into more specific folders, if they aren't really totally general purpose?
6
7 ##############
8
9 # test whether we've been here before or not.
10 skip_all=
11 type function_sentinel &>/dev/null
12 if [ $? -eq 0 ]; then
13   # there was no error, so we can skip the inits.
14   if [ ! -z "$DEBUG_FEISTY_MEOW" ]; then
15     echo "skipping function definitions, because already defined."
16   fi
17   skip_all=yes
18 else
19   skip_all=
20 fi
21
22 if [ -z "$skip_all" ]; then
23
24   if [ ! -z "$DEBUG_FEISTY_MEOW" ]; then
25     echo "feisty meow function definitions beginning now..."
26   fi
27
28   # a handy little method that can be used for date strings.  it was getting
29   # really tiresome how many different ways the script did the date formatting.
30   function date_stringer() {
31     local sep="$1"; shift
32     if [ -z "$sep" ]; then sep='_'; fi
33     date +"%Y$sep%m$sep%d$sep%H%M$sep%S" | tr -d '/\n/'
34   }
35   
36   # a wrapper for the which command that finds items on the path.  some OSes
37   # do not provide which, so we want to not be spewing errors when that
38   # happens.
39   function whichable()
40   {
41     to_find="$1"; shift
42     local WHICHER="$(/usr/bin/which which 2>/dev/null)"
43 #>&2 echo "got whicher as: $WHICHER"
44     if [ $? -ne 0 ]; then
45       # there is no which command here.  we produce nothing due to this.
46       echo
47       return 2
48     fi
49     local sporkenz  # must be defined local here, before call, or we don't get exit value?!
50     sporkenz=$($WHICHER "$to_find" 2>/dev/null)
51 #>&2 echo "broken with this line, but here is exit val: $?"
52     local err=$?
53 #>&2 echo "got whicher as: $WHICHER"
54     echo $sporkenz
55     return $err
56   }
57
58   # makes a directory of the name specified and then tries to change the
59   # current directory to that directory.
60   function mcd() {
61     if [ ! -d "$1" ]; then mkdir -p "$1"; fi
62     cd "$1"
63   }
64
65   # returns true if the variable is an array.
66   function is_array() {
67     [[ "$(declare -p $1)" =~ "declare -a" ]]
68   }
69
70   # returns true if the name provided is a defined alias.
71   function is_alias() {
72     alias $1 &>/dev/null
73     return $?
74   }
75
76   # makes the status of pipe number N (passed as first parameter) into the
77   # main return value (i.e., the value for $?).  this is super handy to avoid
78   # repeating the awkward looking code below in multiple places.
79   # the numbering starts at zero, for the first item at the head of the pipe.
80   function promote_pipe_return()
81   {
82     ( exit ${PIPESTATUS[$1]} )
83   }
84
85   ##############
86
87   function fm_username()
88   {
89     # see if we can get the user name from the login name.  oddly this sometimes doesn't work.
90     local custom_user="$(logname 2>/dev/null)"
91     if [ -z "$custom_user" ]; then
92       # try the normal unix user variable.
93       custom_user="$USER"
94     fi
95     if [ -z "$custom_user" ]; then
96       # try the windows user variable.
97       custom_user="$USERNAME"
98     fi
99     echo "$custom_user"
100   }
101
102   ##############
103
104   # displays the value of a variable in bash friendly format.
105   function var() {
106     HOLDIFS="$IFS"
107     IFS=""
108     while true; do
109       local varname="$1"; shift
110       if [ -z "$varname" ]; then
111         break
112       fi
113
114       if is_alias "$varname"; then
115 #echo found $varname is alias
116         local tmpfile="$(mktemp $TMP/aliasout.XXXXXX)"
117         alias $varname | sed -e 's/.*=//' >$tmpfile
118         echo "alias $varname=$(cat $tmpfile)"
119         \rm $tmpfile
120       elif [ -z "${!varname}" ]; then
121         echo "$varname undefined"
122       else
123         if is_array "$varname"; then
124 #echo found $varname is array var 
125           local temparray
126           eval temparray="(\${$varname[@]})"
127           echo "$varname=(${temparray[@]})"
128 #hmmm: would be nice to print above with elements enclosed in quotes, so that we can properly
129 # see ones that have spaces in them.
130         else
131 #echo found $varname is simple
132           echo "$varname=${!varname}"
133         fi
134       fi
135     done | sort
136     IFS="$HOLDIFS"
137   }
138
139   ##############
140
141   # when passed a list of things, this will return the unique items from that list as an echo.
142   function uniquify()
143   {
144     # do the uniquification: split the space separated items into separate lines, then
145     # sort the list, then run the uniq tool on the list.  results will be packed back onto
146     # one line when invoked like: local fredlist="$(uniquify a b c e d a e f a e d b)"
147     echo $* | tr ' ' '\n' | sort | uniq
148   }
149
150   # sets the variable in parameter 1 to the value in parameter 2, but only if
151   # that variable was undefined.
152   function set_var_if_undefined()
153   {
154     local var_name="$1"; shift
155     local var_value="$1"; shift
156     if [ -z "${!var_name}" ]; then
157       eval export $var_name="$var_value"
158     fi
159   }
160
161   ##############
162
163   function success_sound()
164   {
165     if [ ! -z "$CLAM_FINISH_SOUND" ]; then
166       bash $FEISTY_MEOW_SCRIPTS/multimedia/sound_play.sh "$CLAM_FINISH_SOUND"
167     fi
168   }
169
170   function error_sound()
171   {
172     if [ ! -z "$CLAM_ERROR_SOUND" ]; then
173       bash $FEISTY_MEOW_SCRIPTS/multimedia/sound_play.sh "$CLAM_ERROR_SOUND"
174     fi
175   }
176
177   ##############
178
179   # echoes the maximum number of columns that the terminal supports.  usually
180   # anything you print to the terminal with length less than (but not equal to)
181   # maxcols will never wrap.
182   function get_maxcols()
183   {
184     # calculate the number of columsn in the terminal.
185     local cols=$(stty size | awk '{print $2}')
186     echo $cols
187   }
188
189   ##############
190
191   # checks the result of the last command that was run, and if that failed,
192   # then this complains and exits from bash.  the function parameters are
193   # used as the message to print as a complaint.
194   function exit_on_error()
195   {
196     if [ $? -ne 0 ]; then
197       echo -e "\n\nan important action failed and this script will stop:\n\n$*\n\n*** Exiting script..."
198       error_sound
199       exit 1
200     fi
201   }
202
203   # like exit_on_error, but will keep going after complaining.
204   function continue_on_error()
205   {
206     if [ $? -ne 0 ]; then
207       echo -e "\n\na problem occurred, but we can continue:\n\n$*\n\n=> Continuing script..."
208       error_sound
209     fi
210   }
211
212   ##############
213
214   # accepts any number of arguments and outputs them to the feisty meow event log.
215   function log_feisty_meow_event()
216   {
217     echo -e "$(date_stringer) -- ${USER}@$(hostname): $*" >> "$FEISTY_MEOW_EVENT_LOG"
218   }
219
220   ##############
221
222   # wraps secure shell with some parameters we like, most importantly to enable X forwarding.
223   function ssh()
224   {
225     local args=($@)
226     save_terminal_title  # remember the current terminal title.
227     /usr/bin/ssh -C "${args[@]}"
228 #hmmm: removed -Y flag because considered dangerous to trust remote hosts to not abuse our X session.
229     restore_terminal_title
230   }
231
232   # this version of ssh preserves the use of the -Y flag for when X forwarding is needed.
233   function yssh()
234   {
235     local args=($@)
236     save_terminal_title  # remember the current terminal title.
237     /usr/bin/ssh -Y "${args[@]}"
238     restore_terminal_title
239   }
240
241   ##############
242
243   # locates a process given a search pattern to match in the process list.
244   #
245   # + the -u flag specifies a user name, e.g. "-u joe", which causes only
246   #   the processes of that user "joe" to be considered.
247   #
248   # + the -x flag specifies a pattern to exclude from the list, e.g. "-x pszap.sh"
249   #   would ignore any processes that mention the phrase "pszap.sh".
250   function psfind() {
251     local user_flag="-e"
252       # default user flag is for all users.
253     local excluder="ScrengeflebbitsAPhraseWeNeverExpecttomatchanythingYO298238"
254       # for our default, pick an exclusion string we would never match.
255
256     local found_flag=1
257     while [ $found_flag -eq 1 ]; do
258       # reset our sentinel now that we're safely in our loop.
259       found_flag=0
260
261       # save the first argument, since we're going to shift the args.
262       local arg1="$1"
263       if [ "$arg1" == "-u" ]; then
264         # handle the user flag.
265         user_flag="-u $2" 
266 #echo "found a -u parm and user=$2" 
267         found_flag=1  # signal that we found one.
268         # skip these two arguments, since we've consumed them.
269         shift
270         shift
271       elif [ "$arg1" == "-x" ]; then
272         # handle the exclusion flag.
273         excluder="$2" 
274 #echo "found a -x parm and excluder=$excluder" 
275         found_flag=1  # signal that we found one.
276         # skip these two arguments, since we've consumed them.
277         shift
278         shift
279       fi
280     done
281
282     # now that we've yanked any flags out, we can pull the rest of the
283     # arguments in as patterns to seek in the process list.
284     local -a patterns=("${@}")
285 #echo ====
286 #echo patterns list is: "${patterns[@]}"
287 #echo ====
288
289     local PID_DUMP="$(mktemp "$TMP/zz_pidlist.XXXXXX")"
290     local -a PIDS_SOUGHT
291
292     if [ "$OS" == "Windows_NT" ]; then
293       # gets cygwin's (god awful) ps to show windoze processes also.
294       local EXTRA_DOZER_FLAGS="-W"
295       # pattern to use for peeling off the process numbers.
296 #      local pid_finder_cmd="awk -- '{ print \$4; }'"
297       local field_number=4
298     else
299       # flags which clean up the process listing output on unixes.
300       # apparently cygwin doesn't count as a type of unix, because their
301       # crummy specialized ps command doesn't support normal ps flags.
302       local EXTRA_UNIX_FLAGS="-o pid,args"
303       # pattern to use for peeling off the process numbers.
304 #      local pid_finder_cmd="sed -n -e \\'s/^[[:space:]]*\([0-9][0-9]*\).*$/\\\\1/p\\'"
305 #echo pidfinder: $pid_finder_cmd
306 #      local pid_finder_cmd="awk -- '{ print \$1; }'"
307       local field_number=1
308     fi
309
310     /bin/ps $EXTRA_DOZER_FLAGS $EXTRA_UNIX_FLAGS $user_flag | tail -n +2 >$PID_DUMP
311 #echo ====
312 #echo got all this stuff in the pid dump file:
313 #cat $PID_DUMP
314 #echo ====
315
316     # search for the pattern the user wants to find, and just pluck the process
317     # ids out of the results.
318     local i
319     for i in "${patterns[@]}"; do
320 #echo "pattern curr is '$i'"
321       PIDS_SOUGHT+=($(cat $PID_DUMP \
322         | grep -i "$i" \
323         | grep -v "$excluder" \
324         | awk -- "{ print \$${field_number}; }" ))
325     done
326 #echo ====
327 #echo pids sought list became:
328 #echo "${PIDS_SOUGHT[@]}"
329 #echo ====
330
331     if [ ${#PIDS_SOUGHT[*]} -ne 0 ]; then
332       local PIDS_SOUGHT2=$(printf -- '%s\n' ${PIDS_SOUGHT[@]} | sort | uniq)
333       PIDS_SOUGHT=()
334       PIDS_SOUGHT=${PIDS_SOUGHT2[*]}
335       echo ${PIDS_SOUGHT[*]}
336     fi
337     /bin/rm $PID_DUMP
338   }
339   
340   # finds all processes matching the pattern specified and shows their full
341   # process listing (whereas psfind just lists process ids).
342   function psa() {
343     if [ -z "$1" ]; then
344       echo "psa finds processes by pattern, but there was no pattern on the command line."
345       return 1
346     fi
347     local -a patterns=("${@}")
348     p=$(psfind "${patterns[@]}")
349     if [ -z "$p" ]; then
350       # no matches.
351       return 0
352     fi
353
354     if [ "${patterns[0]}" == "-u" ]; then
355       # void the two elements with that user flag so we don't use them as patterns.
356       unset patterns[0] patterns[1]=
357     fi
358
359     echo ""
360     echo "Processes matching ${patterns[@]}..."
361     echo ""
362     if [ -n "$IS_DARWIN" ]; then
363       unset fuzil_sentinel
364       for i in $p; do
365         # only print the header the first time.
366         if [ -z "$fuzil_sentinel" ]; then
367           ps $i -w -u
368         else
369           ps $i -w -u | sed -e '1d'
370         fi
371         fuzil_sentinel=true
372       done
373     else 
374       # cases besides mac os x's darwin.
375       if [ "$OS" == "Windows_NT" ]; then
376         # special case for windows.
377         ps | head -1
378         for curr in $p; do
379           ps -W -p $curr | tail -n +2
380         done
381       else
382         # normal OSes can handle a nice simple query.
383         ps wu $p
384       fi
385     fi
386   }
387   
388   ##############
389
390 #hmmm: holy crowbars, this is an old one.  do we ever still have any need of it?
391   # an unfortunately similarly named function to the above 'ps' as in process
392   # methods, but this 'ps' stands for postscript.  this takes a postscript file
393   # and converts it into pcl3 printer language and then ships it to the printer.
394   # this mostly makes sense for an environment where one's default printer is
395   # pcl.  if the input postscript causes ghostscript to bomb out, there has been
396   # some good success running ps2ps on the input file and using the cleaned
397   # postscript file for printing.
398   function ps2pcl2lpr() {
399     for $i in $*; do
400       gs -sDEVICE=pcl3 -sOutputFile=- -sPAPERSIZE=letter "$i" | lpr -l 
401     done
402   }
403   
404   function screen() {
405     save_terminal_title
406 #hmmm: ugly absolute path here.
407     /usr/bin/screen $*
408     restore_terminal_title
409   }
410   
411   # switches from a /X/path form to an X:/ form.  this also processes cygwin paths.
412   function unix_to_dos_path() {
413     # we usually remove dos slashes in favor of forward slashes.
414     local DOSSYHOME
415     if [[ ! "$OS" =~ ^[Ww][iI][nN] ]]; then
416       # fake this value for non-windows (non-cygwin) platforms.
417       DOSSYHOME="$HOME"
418     else
419       # for cygwin, we must replace the /home/X path with an absolute one, since cygwin
420       # insists on the /home form instead of /c/cygwin/home being possible.  this is
421       # super frustrating and nightmarish.
422       DOSSYHOME="$(cygpath -am "$HOME")"
423     fi
424
425     if [ ! -z "$SERIOUS_SLASH_TREATMENT" ]; then
426       # unless this flag is set, in which case we force dos slashes.
427       echo "$1" | sed -e "s?^$HOME?$DOSSYHOME?g" | sed -e 's/\\/\//g' | sed -e 's/\/cygdrive//' | sed -e 's/\/\([a-zA-Z]\)\/\(.*\)/\1:\/\2/' | sed -e 's/\//\\/g'
428     else
429       echo "$1" | sed -e "s?^$HOME?$DOSSYHOME?g" | sed -e 's/\\/\//g' | sed -e 's/\/cygdrive//' | sed -e 's/\/\([a-zA-Z]\)\/\(.*\)/\1:\/\2/'
430     fi
431   }
432   
433 #  # switches from an X:/ form to a /cygdrive/X/path form.  this is only useful
434 #  # for the cygwin environment currently.
435 #  function dos_to_unix_path() {
436 #    # we always remove dos slashes in favor of forward slashes.
437 ##old:    echo "$1" | sed -e 's/\\/\//g' | sed -e 's/\([a-zA-Z]\):\/\(.*\)/\/\1\/\2/'
438 #         echo "$1" | sed -e 's/\\/\//g' | sed -e 's/\([a-zA-Z]\):\/\(.*\)/\/cygdrive\/\1\/\2/'
439 #  }
440
441   # returns a successful value (0) if this system is debian or ubuntu.
442   function debian_like() {
443     # decide if we think this is debian or ubuntu or a variant.
444     DEBIAN_LIKE=$(if [ ! -z "$(grep -i debian /etc/issue)" \
445         -o ! -z "$(grep -i ubuntu /etc/issue)" ]; then echo 1; else echo 0; fi)
446     if [ $DEBIAN_LIKE -eq 1 ]; then
447       # success; this is debianish.
448       return 0
449     else
450       # this seems like some other OS.
451       return 1
452     fi
453   }
454   
455   # this function wraps the normal sudo by ensuring we replace the terminal
456   # label before we launch what they're passing to sudo.  we also preserve
457   # specific variables that enable the main user's ssh credentials to still
458   # be relied on for ssh forwarding, even if the '-i' flag is passed to cause
459   # a fresh shell (which normally doesn't get the launching user's environment
460   # variables).
461   function sudo() {
462     save_terminal_title
463
464     # hoist our X authorization info in case environment is passed along;
465     # this can allow root to use our display to show X.org windows.
466     if [ -z "$IMPORTED_XAUTH" -a ! -z "$DISPLAY" ]; then
467       export IMPORTED_XAUTH="$(xauth list $DISPLAY | head -n 1 | awk '{print $3}')"
468       local REMOVE_IMP_XAUTH=true
469     fi
470
471     # launch sudo with just the variables we want to reach the other side.
472     local varmods=
473     varmods+="OLD_HOME=$HOME "
474     if [ ! -z "$IMPORTED_XAUTH" ]; then varmods+="IMPORTED_XAUTH=$IMPORTED_XAUTH "; fi
475     if [ ! -z "$SSH_AUTH_SOCK" ]; then varmods+="SSH_AUTH_SOCK=$SSH_AUTH_SOCK "; fi
476     /usr/bin/sudo $varmods "$@"
477     retval=$?
478
479     # take the xauth info away again if it wasn't set already.
480     if [ ! -z "$REMOVE_IMP_XAUTH" ]; then
481       unset IMPORTED_XAUTH
482     fi
483     restore_terminal_title
484     return $retval
485   }
486   
487   # trashes the .#blah files that cvs and subversion leave behind when finding conflicts.
488   # this kind of assumes you've already checked them for any salient facts.
489   function clean_cvs_junk() {
490     for i in $*; do
491       find $i -follow -type f -iname ".#*" -exec perl $FEISTY_MEOW_SCRIPTS/files/safedel.pl {} ";" 
492     done
493   }
494
495   # overlay for nechung binary so that we can complain less grossly about it when it's missing.
496   function nechung() {
497     local wheres_nechung=$(whichable nechung)
498     if [ -z "$wheres_nechung" ]; then
499       echo "The nechung oracle program cannot be found.  You may want to consider"
500       echo "rebuilding the feisty meow applications with this command:"
501       echo "bash $FEISTY_MEOW_SCRIPTS/generator/produce_feisty_meow.sh"
502       echo
503     else
504       $wheres_nechung
505     fi
506   }
507   
508   # recreates all the generated files that the feisty meow scripts use.
509   function regenerate() {
510     # do the bootstrapping process again.
511     save_terminal_title
512     echo "regenerating feisty meow script environment."
513     bash $FEISTY_MEOW_SCRIPTS/core/reconfigure_feisty_meow.sh
514     echo
515     # force a full reload by turning off sentinel variables and methods.
516     unset -v CORE_VARIABLES_LOADED FEISTY_MEOW_LOADING_DOCK USER_CUSTOMIZATIONS_LOADED \
517         BUILD_VARS_LOADED
518     unalias CORE_ALIASES_LOADED &>/dev/null
519     unset -f function_sentinel 
520
521     # reuse the original path if we can.
522     if [ ! -z "$FEISTY_MEOW_ORIGINAL_PATH" ]; then
523       export PATH="$FEISTY_MEOW_ORIGINAL_PATH"
524     fi
525
526     # reload feisty meow environment in current shell.
527     log_feisty_meow_event "reloading the feisty meow scripts for $USER in current shell."
528     source "$FEISTY_MEOW_SCRIPTS/core/launch_feisty_meow.sh"
529     # run nechung oracle to give user a new fortune.
530     nechung
531     restore_terminal_title
532   }
533
534   # merges a set of custom scripts into the feisty meow environment.  can be
535   # passed a name to use as the custom scripts source folder (found on path
536   # $FEISTY_MEOW_SCRIPTS/customize/{name}), or it will try to guess the name
537   # by using the login name.
538   function recustomize()
539   {
540     local custom_user="$1"; shift
541     if [ -z "$custom_user" ]; then
542       # default to login name if there was no name provided.
543       custom_user="$(fm_username)"
544         # we do intend to use the login name here to get the login name and to ignore
545         # if the user has sudo root access; we don't want to provide a custom
546         # profile for root.
547     fi
548     # chop off any email address style formatting to leave just the name.
549     custom_user="$(echo "$custom_user" | cut -f1 -d'@')"
550
551     save_terminal_title
552
553     if [ ! -d "$FEISTY_MEOW_SCRIPTS/customize/$custom_user" ]; then
554       echo -e "the customization folder for '$custom_user' is missing:
555
556     $FEISTY_MEOW_SCRIPTS/customize/$custom_user
557
558 we will skip recustomization, but these other customizations are available:
559 "
560       # a little tr and sed magic to fix the carriage returns into commas.
561       local line="$(find $FEISTY_MEOW_SCRIPTS/customize -mindepth 1 -maxdepth 1 -type d -exec basename {} ';' | tr '\n' '&' | sed 's/&/, /g' | sed -e 's/, $//')"
562         # make the line feeds and carriage returns manageable with tr.
563         # convert the ampersand, our weird replacement for EOL, with a comma + space in sed.
564         # last touch with sed removes the last comma.
565       echo "    $line"
566       return 1
567     fi
568
569     # recreate the feisty meow loading dock.
570     regenerate >/dev/null
571
572     # jump into the loading dock and make our custom link.
573     pushd "$FEISTY_MEOW_LOADING_DOCK" &>/dev/null
574     if [ -h custom ]; then
575       # there's an existing link, so remove it.
576       \rm custom
577     fi
578     # make sure we cleaned up the area before we re-link.
579     if [ -h custom -o -d custom -o -f custom ]; then
580       echo "
581 Due to an over-abundance of caution, we are not going to remove an unexpected
582 'custom' object found in the file system.  This object is located in the
583 feisty meow loading dock here: $(pwd)
584 And here is a description of the rogue 'custom' object:
585 "
586       ls -al custom
587       echo "
588 If you are pretty sure that this is just a remnant of an older approach in
589 feisty meow, where we copied the custom directory rather than linking it
590 (and it most likely is just such a bit of cruft of that nature), then please
591 remove that old remnant 'custom' item, for example by saying:
592   /bin/rm -rf \"custom\" ; popd
593 Sorry for the interruption, but we want to make sure this removal wasn't
594 automatic if there is even a small amount of doubt about the issue."
595       return 1
596     fi
597
598     # create the custom folder as a link to the customizations.
599     ln -s "$FEISTY_MEOW_SCRIPTS/customize/$custom_user" custom
600
601     popd &>/dev/null
602
603     # now take into account all the customizations by regenerating the feisty meow environment.
604     regenerate
605
606     restore_terminal_title
607   }
608
609   # generates a random password where the first parameter is the number of characters
610   # in the password (default 20) and the second parameter specifies whether to use
611   # special characters (1) or not (0).
612   # found function at http://legroom.net/2010/05/06/bash-random-password-generator
613   function random_password()
614   {
615     [ "$2" == "0" ] && CHAR="[:alnum:]" || CHAR="[:graph:]"
616     cat /dev/urandom | tr -cd "$CHAR" | head -c ${1:-32}
617     echo
618   }
619
620   function add_cygwin_drive_mounts() {
621     for i in c d e f g h q z ; do
622 #hmmm: improve this by not adding the link if already there, or if the drive is not valid.
623       ln -s /cygdrive/$i $i
624     done
625   }
626
627   ############################
628
629   # takes a file to modify, and then it will replace any occurrences of the
630   # pattern provided as the second parameter with the text in the third
631   # parameter.
632   function replace_pattern_in_file()
633   {
634     local file="$1"; shift
635     local pattern="$1"; shift
636     local replacement="$1"; shift
637     if [ -z "$file" -o -z "$pattern" -o -z "$replacement" ]; then
638       echo "replace_pattern_in_file: needs a filename, a pattern to replace, and the"
639       echo "text to replace that pattern with."
640       return 1
641     fi
642     sed -i -e "s%$pattern%$replacement%g" "$file"
643   }
644
645   # similar to replace_pattern_in_file, but also will add the new value
646   # when the old one did not already exist in the file.
647   function replace_if_exists_or_add()
648   {
649     local file="$1"; shift
650     local phrase="$1"; shift
651     local replacement="$1"; shift
652     if [ -z "$file" -o ! -f "$file" -o -z "$phrase" -o -z "$replacement" ]; then
653       echo "replace_if_exists_or_add: needs a filename, a phrase to replace, and the"
654       echo "text to replace that phrase with."
655       return 1
656     fi
657     grep "$phrase" "$file" >/dev/null
658     # replace if the phrase is there, otherwise add it.
659     if [ $? -eq 0 ]; then
660       replace_pattern_in_file "$file" "$phrase" "$replacement"
661     else
662       # this had better be the complete line.
663       echo "$replacement" >>"$file"
664     fi
665   }
666
667   ############################
668
669   # finds a variable (first parameter) in a particular property file
670   # (second parameter).  the expected format for the file is:
671   # varX=valueX
672   function seek_variable()
673   {
674     local find_var="$1"; shift
675     local file="$1"; shift
676     if [ -z "$find_var" -o -z "$file" -o ! -f "$file" ]; then
677       echo -e "seek_variable: needs two parameters, firstly a variable name, and\nsecondly a file where the variable's value will be sought." 1>&2
678       return 1
679     fi
680   
681     while read line; do
682       if [ ${#line} -eq 0 ]; then continue; fi
683       # split the line into the variable name and value.
684       IFS='=' read -a assignment <<< "$line"
685       local var="${assignment[0]}"
686       local value="${assignment[1]}"
687       if [ "${value:0:1}" == '"' ]; then
688         # assume the entry was in quotes and remove them.
689         value="${value:1:$((${#value} - 2))}"
690       fi
691       if [ "$find_var" == "$var" ]; then
692         echo "$value"
693       fi
694     done < "$file"
695   }
696   
697   # finds a variable (first parameter) in a particular XML format file
698   # (second parameter).  the expected format for the file is:
699   # ... name="varX" value="valueX" ...
700   function seek_variable_in_xml()
701   {
702     local find_var="$1"; shift
703     local file="$1"; shift
704     if [ -z "$find_var" -o -z "$file" -o ! -f "$file" ]; then
705       echo "seek_variable_in_xml: needs two parameters, firstly a variable name, and"
706       echo "secondly an XML file where the variable's value will be sought."
707       return 1
708     fi
709   
710     while read line; do
711       if [ ${#line} -eq 0 ]; then continue; fi
712       # process the line to make it more conventional looking.
713       line="$(echo "$line" | sed -e 's/.*name="\([^"]*\)" value="\([^"]*\)"/\1=\2/')"
714       # split the line into the variable name and value.
715       IFS='=' read -a assignment <<< "$line"
716       local var="${assignment[0]}"
717       local value="${assignment[1]}"
718       if [ "${value:0:1}" == '"' ]; then
719         # assume the entry was in quotes and remove them.
720         value="${value:1:$((${#value} - 2))}"
721       fi
722       if [ "$find_var" == "$var" ]; then
723         echo "$value"
724       fi
725     done < "$file"
726   }
727   
728   ############################
729
730   # goes to a particular directory passed as parameter 1, and then removes all
731   # the parameters after that from that directory.
732   function push_whack_pop()
733   {
734     local dir="$1"; shift
735     pushd "$dir" &>/dev/null
736     if [ $? -ne 0 ]; then echo failed to enter dir--quitting.; fi
737     rm -rf $* &>/dev/null
738     if [ $? -ne 0 ]; then echo received a failure code when removing.; fi
739     popd &>/dev/null
740   }
741
742   ##############
743
744 # new breed of definer functions goes here.  still in progress.
745
746   # defines an alias and remembers that this is a new or modified definition.
747   # if the feisty meow codebase is unloaded, then so are all the aliases that
748   # were defined.
749   function define_yeti_alias()
750   {
751 # if alias exists already, save old value for restore,
752 # otherwise save null value for restore,
753 # have to handle unaliasing if there was no prior value of one
754 # we newly defined.
755 # add alias name to a list of feisty defined aliases.
756
757 #hmmm: first implem, just do the alias and get that working...
758 alias "${@}"
759
760
761 return 0
762   }
763
764   ##############
765
766 #hmmm: this points to an extended functions file being needed; not all of these are core.
767
768   # displays documentation in "md" formatted files.
769   function show_md()
770   {
771     local file="$1"; shift
772     pandoc "$file" | lynx -stdin
773   }
774
775   ##############
776
777   # just shows a separator line for an 80 column console, or uses the first
778   # parameter as the number of columns to expect.
779   function separator()
780   {
781     count=$1; shift
782     if [ -z "$count" ]; then
783       count=$(($COLUMNS - 1))
784     fi
785     echo
786     local i
787     for ((i=0; i < $count; i++)); do
788       echo -n "="
789     done
790     echo
791     echo
792   }
793   # alias for separator.
794   function sep()
795   {
796     separator $*
797   }
798
799   ##############
800
801   # count the number of sub-directories in a directory and echo the result.
802   function count_directories()
803   {
804     local subbydir="$1"; shift
805     numdirs="$(find "$subbydir" -mindepth 1 -maxdepth 1 -type d | wc -l)"
806     echo $numdirs
807   }
808
809   # takes a string and capitalizes just the first character.  any capital letters in the remainder of
810   # the string are made lower case.  the processed string is returned by an echo.
811   function capitalize_first_char()
812   {
813     local to_dromedary="$1"; shift
814     to_dromedary="$(tr '[:lower:]' '[:upper:]' <<< ${to_dromedary:0:1})$(tr '[:upper:]' '[:lower:]' <<< ${to_dromedary:1})"
815     echo "$to_dromedary"
816   }
817
818   # given a source path and a target path, this will make a symbolic link from
819   # the source to the destination, but only if the source actually exists.
820   function make_safe_link()
821   {
822     local src="$1"; shift
823     local target="$1"; shift
824   
825     if [ -d "$src" ]; then
826       ln -s "$src" "$target"
827       exit_on_error "Creating symlink from '$src' to '$target'"
828     fi
829     echo "Created symlink from '$src' to '$target'."
830   }
831
832   # pretty prints the json files provided as parameters.
833   function clean_json()
834   {
835     if [ -z "$*" ]; then return; fi
836     local show_list=()
837     while true; do
838       local file="$1"; shift
839       if [ -z "$file" ]; then break; fi
840       if [ ! -f "$file" ]; then "echo File '$file' does not exist."; continue; fi
841       temp_out="$TMP/$file.view"
842       cat "$file" | python -m json.tool > "$temp_out"
843       show_list+=($temp_out)
844       continue_on_error "pretty printing '$file'"
845     done
846     filedump "${show_list[@]}"
847     rm "${show_list[@]}"
848   }
849
850   function json_text()
851   {
852     # only print our special headers or text fields.
853     local CR=$'\r'
854     local LF=$'\n'
855     clean_json $* |
856         grep -i "\"text\":\|^=.*" | 
857         sed -e "s/\\\\r/$CR/g" -e "s/\\\\n/\\$LF/g"
858   }
859
860   ##############
861
862   # echoes the machine's hostname.  can be used like so:
863   #   local my_host=$(get_hostname)
864   function get_hostname()
865   {
866     # there used to be more variation in how to do this, but adopting mingw
867     # and cygwin tools really helped out.
868     local this_host=unknown
869     if [ "$OS" == "Windows_NT" ]; then
870       this_host=$(hostname)
871     elif [ ! -z "$(echo $MACHTYPE | grep apple)" ]; then
872       this_host=$(hostname)
873     elif [ ! -z "$(echo $MACHTYPE | grep suse)" ]; then
874       this_host=$(hostname --long)
875     elif [ -x "$(whichable hostname)" ]; then
876       this_host=$(hostname)
877     fi
878     echo "$this_host"
879   }
880
881   # makes sure that the provided "folder" is a directory and is writable.
882   function test_writeable()
883   {
884     local folder="$1"; shift
885     if [ ! -d "$folder" -o ! -w "$folder" ]; then return 1; fi
886     return 0
887   }
888
889   ##############
890
891   # given a filename and a string to seek and a number of lines, then this
892   # function will remove the first occurrence of a line in the file that
893   # matches the string, and it will also axe the next N lines as specified.
894   function create_chomped_copy_of_file()
895   {
896     local filename="$1"; shift
897     local seeker="$1"; shift
898     local numlines=$1; shift
899
900 #echo into create_chomped_copy...
901 #var filename seeker numlines 
902
903     # make a backup first, oy.
904     \cp -f "$filename" "/tmp/$(basename ${filename}).bkup-${RANDOM}" 
905     exit_on_error "backing up file: $filename"
906
907     # make a temp file to write to before we move file into place in bind.
908     local new_version="/tmp/$(basename ${filename}).bkup-${RANDOM}" 
909     \rm -f "$new_version"
910     exit_on_error "cleaning out new version of file from: $new_version"
911
912     local line
913     local skip_count=0
914     local found_any=
915     while read line; do
916       # don't bother looking at the lines if we're already in skip mode.
917       if [[ $skip_count == 0 ]]; then
918         # find the string they're seeking.
919         if [[ ! "$line" =~ .*${seeker}.* ]]; then
920           # no match.
921           echo "$line" >> "$new_version"
922         else
923           # a match!  start skipping.  we will delete this line and the next N lines.
924           ((skip_count++))
925 #echo first skip count is now $skip_count
926           found_any=yes
927         fi
928       else
929         # we're already skipping.  let's keep going until we hit the limit.
930         ((skip_count++))
931 #echo ongoing skip count is now $skip_count
932         if (( $skip_count > $numlines )); then
933           echo "Done skipping, and back to writing output file."
934           skip_count=0
935         fi
936       fi
937     done < "$filename"
938
939 #echo file we created looks like this:
940 #cat "$new_version"
941
942     if [ ! -z "$found_any" ]; then
943       # put the file back into place under the original name.
944       \mv "$new_version" "$filename"
945       exit_on_error "moving the new version into place in: $filename"
946     else
947       # cannot always be considered an error, but we can at least gripe.
948       echo "Did not find any matches for seeker '$seeker' in file: $filename"
949     fi
950   }
951
952   ##############
953
954   # space 'em all: fixes naming for all of the files of the appropriate types
955   # in the directories specified.  we skip any file with a dot in front, to
956   # respect their hidden nature.  currently the set of files we'll rename is
957   # very boutique; it's in this function, and just happens to be the types of
958   # files we work with a lot.
959   function spacemall() {
960     local -a dirs=("${@}")
961     if [ ${#dirs[@]} -eq 0 ]; then
962       dirs=(.)
963     fi
964
965     local charnfile="$(mktemp $TMP/zz_charn.XXXXXX)"
966 #hmmm: any way to do the below more nicely or reusably?
967 #hmmm: yes!  a variable with a list of files that are considered TEXT_FILE_EXTENSIONS or something like that.
968 #hmmm: yes continued!  also a variable for BINARY_FILE_EXTENSIONS to avoid those, where we need to in other scripts.
969 #hmmm: wait, we actually have a mix here, since this is a renaming function and not a searching function; get it straight!
970 #hmmm: would the composition of those two types of extensions cover all the files i want to rename?  they have to be "important".
971     find "${dirs[@]}" -follow -maxdepth 1 -mindepth 1 -type f -and -not -iname ".[a-zA-Z0-9]*" | \
972         grep -i \
973 "csv\|doc\|docx\|eml\|html\|ics\|jpeg\|jpg\|m4a\|mov\|mp3\|odp\|ods\|odt\|pdf\|png\|ppt\|pptx\|rtf\|txt\|vsd\|vsdx\|wav\|xls\|xlsx\|xml\|zip" | \
974         sed -e 's/^/"/' | sed -e 's/$/"/' | \
975         xargs bash "$FEISTY_MEOW_SCRIPTS/files/spacem.sh"
976     # drop the temp file now that we're done.
977     rm "$charnfile"
978   }
979
980   ##############
981
982   # tty relevant functions...
983
984   # keep_awake: sends a message to the screen from the background.
985   function keep_awake()
986   {
987     # just starts the keep_awake process in the background.
988     bash $FEISTY_MEOW_SCRIPTS/tty/keep_awake_process.sh &
989       # this should leave the job running as %1 or a higher number if there
990       # are pre-existing background jobs.
991   }
992
993   ##############
994
995   # site avenger functions...
996
997   function switchto()
998   {
999     THISDIR="$FEISTY_MEOW_SCRIPTS/site_avenger"
1000     source "$FEISTY_MEOW_SCRIPTS/site_avenger/shared_site_mgr.sh"
1001     switch_to "$1"
1002   }
1003
1004   ##############
1005
1006   # you have hit the borderline functional zone...
1007
1008 #hmmm: not really doing anything yet; ubuntu seems to have changed from pulseaudio in 17.04?
1009   # restarts the sound driver.
1010   function fix_sound_driver() {
1011     # stop bash complaining about blank function body.
1012     local nothing=
1013 #if alsa something
1014 #    sudo service alsasound restart
1015 #elif pulse something
1016 #    sudo pulseaudio -k
1017 #    sudo pulseaudio -D
1018 #else
1019 #    something else...?
1020 #fi
1021
1022   }
1023
1024   # ...and here's the end of the borderline functional zone.
1025
1026   ##############
1027
1028   # NOTE: no more function definitions are allowed after this point.
1029
1030   function function_sentinel()
1031   {
1032     return 0; 
1033   }
1034   
1035   if [ ! -z "$DEBUG_FEISTY_MEOW" ]; then echo "feisty meow function definitions done."; fi
1036
1037   ##############
1038
1039   # test code for set_var_if_undefined.
1040   run_test=0
1041   if [ $run_test != 0 ]; then
1042     echo running tests on set_var_if_undefined.
1043     flagrant=petunia
1044     set_var_if_undefined flagrant forknordle
1045     exit_on_error "testing if defined variable would be whacked"
1046     if [ $flagrant != petunia ]; then
1047       echo set_var_if_undefined failed to leave the test variable alone
1048       exit 1
1049     fi
1050     unset bobblehead_stomper
1051     set_var_if_undefined bobblehead_stomper endurance
1052     if [ $bobblehead_stomper != endurance ]; then
1053       echo set_var_if_undefined failed to set a variable that was not defined yet
1054       exit 1
1055     fi
1056   fi
1057
1058 fi
1059